// ImgToolDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ImgTool.h"
#include "ImgToolDlg.h"
#include "VisCore.h"
#include "MilLib.h"
#include "Tif2Bmp.h"

extern CMilLib mil;

CImgToolDlg *theDlg;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CImgToolDlg dialog

CImgToolDlg::CImgToolDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CImgToolDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CImgToolDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CImgToolDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CImgToolDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CImgToolDlg, CDialog)
	//{{AFX_MSG_MAP(CImgToolDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTN_AVG, OnBtnAvg)
	ON_BN_CLICKED(IDC_BTN_BMP, OnBtnBmp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CImgToolDlg message handlers

BOOL CImgToolDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	((CButton*)GetDlgItem(IDC_COLOR_AUTO))->SetCheck(true);

	theDlg = this;
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CImgToolDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CImgToolDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CImgToolDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CImgToolDlg::OnBtnAvg() 
{
	char input[10000] = "";
	char path[100] = "";

	CFileDialog openDlg(true,NULL,NULL,OFN_ALLOWMULTISELECT,"BMP Files (*.bmp)|*.bmp|",this);

	GetCurrentDirectory(100,path);
	openDlg.m_ofn.lpstrInitialDir = path;
	openDlg.m_ofn.lpstrFile = input;
	openDlg.m_ofn.nMaxFile = 10000;
	char opentitle[] = "Images to Average";
	openDlg.m_ofn.lpstrTitle = opentitle;

	if (openDlg.DoModal() == IDCANCEL) return;

	CFileDialog saveDlg(false,NULL,NULL,OFN_OVERWRITEPROMPT,"BMP Files (*.bmp)|*.bmp|",this);

	saveDlg.m_ofn.lpstrInitialDir = openDlg.GetPathName();
	char savetitle[] = "Save Average As";
	saveDlg.m_ofn.lpstrTitle = savetitle;

	if (saveDlg.DoModal() == IDCANCEL) return;

	double *totals = NULL;
	POSITION p = openDlg.GetStartPosition();
	int height, width;
	int count = 0;

	while (p)
	{
		CString fname;
		fname = openDlg.GetNextPathName(p);
		this->SetDlgItemText(IDC_TXT_STATUS,"Processing "+fname+"...");
		this->UpdateWindow();

		CVisRGBAByteImage I;
		I.ReadFile(fname);
		
		if (!totals)
		{
			height = I.Height();
			width = I.Width();
			totals = new double[height*width*3];
			for (int i = 0; i < height*width*3; i++)
				totals[i] = 0;
		}

		for (int y = 0; y < height; y++)
			for (int x = 0; x < width; x++)
			{
				totals[3*(y*width+x)+0] += I.Pixel(x,y).R();
				totals[3*(y*width+x)+1] += I.Pixel(x,y).G();
				totals[3*(y*width+x)+2] += I.Pixel(x,y).B();
			}

		count++;
	}

	if (count > 0)
	{
		CVisRGBAByteImage I(width,height);

		double total = 0;

		for (int y = 0; y < height; y++)
			for (int x = 0; x < width; x++)
			{
				I.Pixel(x,y).SetR(totals[3*(y*width+x)+0]/count);
				I.Pixel(x,y).SetG(totals[3*(y*width+x)+1]/count);
				I.Pixel(x,y).SetB(totals[3*(y*width+x)+2]/count);
				total += abs(I.Pixel(x,y).R()-I.Pixel(x,y).G())
						+  abs(I.Pixel(x,y).R()-I.Pixel(x,y).B())
						+  abs(I.Pixel(x,y).G()-I.Pixel(x,y).B());
			}

		if (total > 0)
			I.WriteFile(saveDlg.GetPathName());
		else
		{
			CVisByteImage J(width,height);
			for (int y = 0; y < height; y++)
				for (int x = 0; x < width; x++)
					J.Pixel(x,y) = I.Pixel(x,y).R();
			J.WriteFile(saveDlg.GetPathName());
		}
	}

	this->SetDlgItemText(IDC_TXT_STATUS,"Ready.");
}

UINT ProcessTif( LPVOID pParam )
{
	CFileDialog *openDlg = (CFileDialog*)pParam;

	POSITION p = openDlg->GetStartPosition();

	while (p)
	{
		CString fname;
		fname = openDlg->GetNextPathName(p);
		theDlg->SetDlgItemText(IDC_TXT_STATUS,"Processing "+fname+"...");

		CVisByteImage I;
		mil.LoadCFAImage(fname,I);
		//I.ReadFile(fname);

		bool isColor;
		if (((CButton*)theDlg->GetDlgItem(IDC_COLOR_AUTO))->GetCheck())
			isColor = !IsBlackWhite(I);
		if (((CButton*)theDlg->GetDlgItem(IDC_COLOR_COL))->GetCheck())
			isColor = true;
		if (((CButton*)theDlg->GetDlgItem(IDC_COLOR_GRAY))->GetCheck())
			isColor = false;

		CString fname_ = fname.Left(fname.GetLength()-3)+"bmp";
		if (isColor)
		{
			CVisRGBAByteImage J;
			//TIF2HiBMP(I,J);
			//InterpolateBMP(I,J);
			ToColor(I,J);
			J.WriteFile(fname_);
		}
		else
			I.WriteFile(fname_);

		if (((CButton*)theDlg->GetDlgItem(IDC_REMOVE_TIF))->GetCheck())
			DeleteFile(fname);
	}

	theDlg->SetDlgItemText(IDC_TXT_STATUS,"Ready.");

	return 0;
}

void CImgToolDlg::OnBtnBmp() 
{
	char input[10000] = "";
	char path[100] = "";

	CFileDialog openDlg(true,NULL,NULL,OFN_ALLOWMULTISELECT,"TIF Files (*.tif)|*.tif|",this);

	GetCurrentDirectory(100,path);
	openDlg.m_ofn.lpstrInitialDir = path;
	openDlg.m_ofn.lpstrFile = input;
	openDlg.m_ofn.nMaxFile = 10000;
	char opentitle[] = "TIF Files to Convert";
	openDlg.m_ofn.lpstrTitle = opentitle;

	if (openDlg.DoModal() == IDCANCEL) return;

	AfxBeginThread(ProcessTif,&openDlg,THREAD_PRIORITY_BELOW_NORMAL);
}
